<template>
    <div id="app" class="uk-background-secondary">
        <Menu />
        <div
            uk-sticky="sel-target: .uk-navbar-container; cls-active: uk-navbar-sticky"
        >
            <nav class="uk-navbar-container" uk-navbar>
                <div class="uk-navbar-left uk-margin-left">
                    <ul class="uk-iconnav">
                        <li
                            class="uk-margin-small-right"
                            uk-icon="menu"
                            uk-toggle="target: #menu-slide"
                        />
                    </ul>
                </div>
                <div class="uk-navbar-right uk-margin-right">
                    <ul class="uk-iconnav uk-margin-right">
                        <li>
                            <router-link
                                v-if="this.$auth.isAuthenticated"
                                tag="a"
                                to="Profil"
                                style="display: initial"
                            >
                                Salut, {{ this.$auth.user.prenom }}
                            </router-link>
                            <a
                                v-else
                                uk-toggle="target: #auth-modal"
                                style="display: initial"
                                >Se connecter</a
                            >
                        </li>
                        <li
                            uk-icon="bell"
                            v-if="this.notif.length > 0"
                            class="red uk-icon"
                            v-on:click="afficherNotification"
                        />
                        <li uk-icon="bell" class="uk-icon" v-else />
                    </ul>
                    <router-link
                        tag="a"
                        to="Accueil"
                        class="uk-navbar-item uk-logo"
                    >
                        Gollege
                    </router-link>
                </div>
            </nav>
        </div>
        <FenetreConnexion />
        <div
            class="uk-container uk-background-default"
            uk-height-viewport="expand: true"
            id="main-container"
        >
            <router-view></router-view>
        </div>
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import UIkit from 'uikit';
import Icons from 'uikit/dist/js/uikit-icons';
import Menu from '@/views/Menu.vue';
import Sockjs from 'sockjs-client';
import Stomp from 'webstomp-client';
import Axios from '@/auth/axiosAuth';
import FenetreConnexion from './views/auth/FenetreConnexion.vue';

UIkit.use(Icons);

@Component({
    components: { Menu, FenetreConnexion },
})
export default class App extends Vue {
    public notif: any[] = [];
    public client: any;

    public mounted() {
        this.connect();
    }

    public afficherNotification() {
        this.notif.forEach((element) => {
            UIkit.notification(element);
        });
        this.notif = [];
    }

    public connect() {
        if (!this.$auth.isConnecte()) {
            this.$auth.reconnect();
        }
        if (this.$auth.isConnecte() && this.$auth.user.id != undefined) {
            const sock = new Sockjs(this.$websocket);

            this.client = Stomp.over(sock);
            const notifications = this.notif;
            this.client.connect({ username: this.$auth.user.id }, (frame) => {
                this.client.subscribe(
                    '/users/queue/notifications',
                    function (msgOut) {
                        const notification = msgOut.body;
                        if (notifications.indexOf(notification) == -1) {
                            notifications.push(notification);
                        }
                    },
                );
                Axios.post('notification/' + this.$auth.user.id, null);
            });
        } else {
            setTimeout(() => {
                this.connect();
            }, 100);
        }
    }
}
</script>

<style lang="scss">
@import '../node_modules/uikit/src/scss/variables-theme.scss';
@import '../node_modules/uikit/src/scss/mixins-theme.scss';
@import '../node_modules/uikit/src/scss/uikit-theme.scss';
@import '../node_modules/vue-multiselect/dist/vue-multiselect.min.css';

.red.uk-icon[uk-icon='bell'] svg path {
    fill: #1e87f0;
}
.uk-notification-message {
    background-color: #ecebeb;
}

.uk-heading-small {
    margin-top: 10px;
}
</style>
